variables:
  PIPELINE_BOOT_NAME: "CDBA $VARIANT Linux $KERNEL_VERSION Boot Pipeline"

workflow:
  name: '$PIPELINE_BOOT_NAME'

stages:
  - boot

.test:
  stage: boot
  tags:
    - cdba-runner
  image: artifacts.codelinaro.org/linaro-260-ubuntu/ubuntu-24.04-qcomlt-ci
  # Allow up to 2 retries
  retry: 2
  before_script:
    - git clone --depth 1 https://android.googlesource.com/platform/system/tools/mkbootimg
    - git clone --depth=1 https://github.com/linux-msm/cdba.git /tmp/cdba
    - meson setup -D server=disabled /tmp/cdba/ /tmp/cdba/build
    - ninja -C /tmp/cdba/build cdba
    - eval $(ssh-agent -s)
    - chmod 400 $SSH_PRIVATE_KEY
    - ssh-add "$SSH_PRIVATE_KEY"
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - cp "$SSH_KNOWN_HOSTS" ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    - echo "ServerAliveInterval 10" > ~/.ssh/config
    - chmod 644 ~/.ssh/config
  script:
    - tar xfJ dtbs.tar.xz
    # Decompress only if needed
    - if grep -c "Image.gz" images/${BOARD_TYPE}.sh; then echo "No need to decompress"; else gunzip -k Image.gz; fi
    - |
      if [ -e /srv/ci-board-firmware/${BOARD_TYPE}.cpio.gz ]; then
        cat /srv/ci-board-firmware/${BOARD_TYPE}.cpio.gz >> final-initramfs.cpio.gz
      fi
    - BOOTIMAGE_OUTPUT=images/${BOARD_TYPE}.img sh images/${BOARD_TYPE}.sh
    - /tmp/cdba/build/cdba -h ${CDBA_HOST} -b ${BOARD_ID} -c0 -t 1200 -T 1200 images/${BOARD_TYPE}.img | tee boot.log
    # Check if ci-testsuite has finished if cdba run is successful, otherwise fail
    - grep -c "TEST_CASE_ID=testsuite-loop RESULT=pass" boot.log
  after_script:
    - python3 test_signal_parser.py -l boot.log -x junit.xml
    - killall -q -9 cdba
  needs:
    - pipeline: $PARENT_PIPELINE_ID
      job: $PARENT_PIPELINE_JOB
  artifacts:
    paths:
      - boot.log
      - junit.xml
    reports:
      junit: junit.xml
    expire_in: never

{% for board in boards %}
{{ boards[board].type }}@{{ boards[board].id }}:
  extends:
    - .test
  resource_group: {{ boards[board].type }}_{{ boards[board].id }}
  variables:
    CDBA_HOST: "{{ boards[board].host }}"
    BOARD_ID: "{{ boards[board].id }}"
    BOARD_TYPE: "{{ boards[board].type }}"
{% endfor %}
